## cwl-utils 0.22

=== Makefile ===
# This file is part of cwl-utils,
# https://github.com/common-workflow-language/cwl-utils/, and is
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.
#
# Contact: common-workflow-language@googlegroups.com

# make format to fix most python formatting errors
# make pylint to check Python code for enhanced compliance including naming
#  and documentation
# make coverage-report to check coverage of the python scripts by the tests

MODULE=cwl_utils
PACKAGE=cwl-utils
EXTRAS=

# `SHELL=bash` doesn't work for some, so don't use BASH-isms like
# `[[` conditional expressions.
PYSOURCES=$(filter-out $(MODULE)/parser/cwl_v%,$(shell find $(MODULE) -name "*.py")) \
	  $(wildcard tests/*.py) create_cwl_from_objects.py load_cwl_by_path.py \
	  setup.py ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
DEVPKGS=diff_cover black pylint pep257 pydocstyle flake8 tox tox-pyenv \
	isort wheel autoflake flake8-bugbear pyupgrade bandit \
	-rtest-requirements.txt -rmypy-requirements.txt
DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
	   python-flake8 python-mock shellcheck
VERSION=v$(shell echo $$(tail -n 1 cwl_utils/__meta__.py | awk '{print $$3}'))
mkfile_dir := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
UNAME_S=$(shell uname -s)

## all                    : default task (install cwl-utils in dev mode)
all: dev

## help                   : print this help message and exit
help: Makefile
	@sed -n 's/^##//p' $<

## cleanup                : shortcut for "make sort_imports format flake8 diff_pydocstyle_report"
cleanup: sort_imports format flake8 diff_pydocstyle_report

## install-dep            : install most of the development dependencies via pip
install-dep: install-dependencies

install-dependencies:
	pip install --upgrade $(DEVPKGS)
	pip install -r requirements.txt -r mypy-requirements.txt -r docs/requirements.txt

## install-deb-dep        : install many of the dev dependencies via apt-get
install-deb-dep:
	sudo apt-get install $(DEBDEVPKGS)

## install                : install the cwl-utils package and the scripts
install: FORCE
	pip install .$(EXTRAS)

## dev                    : install the cwl-utils package in dev mode
dev: install-dep
	pip install -e .$(EXTRAS)

## dist                   : create a module package for distribution
dist: dist/${MODULE}-$(VERSION).tar.gz

dist/${MODULE}-$(VERSION).tar.gz: $(SOURCES)
	python setup.py sdist bdist_wheel

## docs                   : make the docs
docs: FORCE
	cd docs && $(MAKE) html

## clean                  : clean up all temporary / machine-generated files
clean: FORCE
	rm -f ${MODILE}/*.pyc tests/*.pyc
	python setup.py clean --all || true
	rm -Rf .coverage
	rm -f diff-cover.html

# Linting and code style related targets
## sort_import            : sorting imports using isort: https://github.com/timothycrosley/isort
sort_imports: $(PYSOURCES)
	isort $^

remove_unused_imports: $(PYSOURCES)
	autoflake --in-place --remove-all-unused-imports $^

pep257: pydocstyle
## pydocstyle             : check Python docstring style
pydocstyle: $(PYSOURCES)
	pydocstyle --add-ignore=D100,D101,D102,D103 $^ || true

pydocstyle_report.txt: $(PYSOURCES)
	pydocstyle setup.py $^ > $@ 2>&1 || true

## diff_pydocstyle_report : check Python docstring style for changed files only
diff_pydocstyle_report: pydocstyle_report.txt
	diff-quality --compare-branch=main --violations=pydocstyle --fail-under=100 $^

## codespell              : check for common misspellings
codespell:
	codespell -w $(shell git ls-files | grep -v mypy-stubs)

## format                 : check/fix all code indentation and formatting (runs black)
format: $(PYSOURCES)
	black $^

format-check: $(PYSOURCES)
	black --diff --check $^

## pylint                 : run static code analysis on Python code
pylint: $(PYSOURCES)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
                $^ -j0|| true

pylint_report.txt: $(PYSOURCES)
	pylint --msg-template="{path}:{line}: [{msg_id}({symbol}), {obj}] {msg}" \
		$^ -j0> $@ || true

diff_pylint_report: pylint_report.txt
	diff-quality --compare-branch=main --violations=pylint pylint_report.txt

.coverage: testcov

coverage: .coverage
	coverage report

coverage.xml: .coverage
	coverage xml

coverage.html: htmlcov/index.html

htmlcov/index.html: .coverage
	coverage html
	@echo Test coverage of the Python code is now in htmlcov/index.html

coverage-report: .coverage
	coverage report

diff-cover: coverage.xml
	diff-cover --compare-branch=main $^

diff-cover.html: coverage.xml
	diff-cover --compare-branch=main $^ --html-report $@

## test                   : run the cwl-utils test suite
test: $(PYSOURCES)
	python -m pytest -rs ${PYTEST_EXTRA}

## testcov                : run the cwl-utils test suite and collect coverage
testcov: $(PYSOURCES)
	pytest --cov ${PYTEST_EXTRA}

sloccount.sc: $(PYSOURCES) Makefile
	sloccount --duplicates --wide --details $^ > $@

## sloccount              : count lines of code
sloccount: $(PYSOURCES) Makefile
	sloccount $^

list-author-emails:
	@echo 'name, E-Mail Address'
	@git log --format='%aN,%aE' | sort -u | grep -v 'root'

mypy3: mypy
mypy: $(filter-out setup.py,${PYSOURCES})
	MYPYPATH=$$MYPYPATH:mypy-stubs mypy $^

mypy_3.6: $(filter-out setup.py,${PYSOURCES})
	MYPYPATH=$$MYPYPATH:mypy-stubs mypy --python-version 3.6 $^

shellcheck: FORCE
	shellcheck release-test.sh

pyupgrade: $(PYSOURCES)
	pyupgrade --exit-zero-even-if-changed --py36-plus $^

release-test: FORCE
	git diff-index --quiet HEAD -- || ( echo You have uncommitted changes, please commit them and try again; false )
	./release-test.sh

release: release-test
	. testenv2/bin/activate && \
		python testenv2/src/${PACKAGE}/setup.py sdist bdist_wheel
	. testenv2/bin/activate && \
		pip install twine && \
		twine upload testenv2/src/${PACKAGE}/dist/* && \
		git tag ${VERSION} && git push --tags

flake8: $(PYSOURCES)
	flake8 $^

cwl_utils/parser/cwl_v1_0.py: FORCE
	schema-salad-tool --codegen python \
		--codegen-parser-info "org.w3id.cwl.v1_0" \
		https://github.com/common-workflow-language/common-workflow-language/raw/codegen/v1.0/CommonWorkflowLanguage.yml \
		> $@

cwl_utils/parser/cwl_v1_1.py: FORCE
	schema-salad-tool --codegen python \
		--codegen-parser-info "org.w3id.cwl.v1_1" \
		https://github.com/common-workflow-language/cwl-v1.1/raw/codegen/CommonWorkflowLanguage.yml \
		> $@

cwl_utils/parser/cwl_v1_2.py: FORCE
	schema-salad-tool --codegen python \
		--codegen-parser-info "org.w3id.cwl.v1_2" \
		https://github.com/common-workflow-language/cwl-v1.2/raw/1.2.1_proposed/CommonWorkflowLanguage.yml \
		> $@

regen_parsers: cwl_utils/parser/cwl_v1_*.py

FORCE:

# Use this to print the value of a Makefile variable
# Example `make print-VERSION`
# From https://www.cmcrossroads.com/article/printing-value-makefile-variable
print-%  : ; @echo $* = $($*)

=== requirements.txt ===
cwl-upgrader >= 1.2.3
packaging
rdflib
requests
CacheControl
schema-salad >= 8.3.20220825114525, < 9

=== docs/requirements.txt ===
sphinx >= 2.2
sphinx-rtd-theme
sphinx-autoapi
sphinx-autodoc-typehints
typed_ast;python_version<'3.8'
sphinxcontrib-autoprogram

## cwl-utils 0.20

=== debian/changelog ===
cwl-utils (0.20-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 16 Oct 2022 14:47:33 +0200

cwl-utils (0.17-2) unstable; urgency=medium

  * Depend on python3-filelock while we wait for the new python3-schema-salad.
  * Delete problematic test file that depends on the unpackaged cwlformat
    as --ignore{,-glob} was not working with pytest in the autopkgtests
  * Drop useless Testsuite: autopkgtest-pkg-python, we have a better one
  * Trim install deps of cwl-utils

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 16 Oct 2022 14:46:14 +0200

cwl-utils (0.17-1) unstable; urgency=low

  * Initial release. Closes: #1018887

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 02 Sep 2022 13:29:56 +0200

=== debian/control ===
Source: cwl-utils
Section: python
Priority: optional
Maintainer: Debian Python Team <team+python@tracker.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-python,
               cwl-upgrader,
               python3-all,
               python3-cachecontrol,
               python3-packaging,
               python3-rdflib,
               python3-requests,
               python3-schema-salad (>= 8.3),
               python3-filelock <!nocheck>,
               python3-setuptools,
               python3-pytest <!nocheck>
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils
Vcs-Git: https://salsa.debian.org/python-team/packages/cwl-utils.git
Homepage: https://github.com/common-workflow-language/cwl-utils
Rules-Requires-Root: no

Package: python3-cwl-utils
Architecture: all
Depends: ${misc:Depends}, ${python3:Depends}, python3-filelock
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}, cwl-utils
Description: Python Utilities and Autogenerated Classes for CWL v1.0 - v1.2
 The autogenerated classes can create, load, and save objects based upon CWL
 (the Common Workflow Language open standards for executable descriptions of
 comandline tools and workflows made from them).
 .
 See the 'cwl-utils' package for command line utilities that use these classes.

Package: cwl-utils
Architecture: all
Depends: ${misc:Depends}, python3-cwl-utils (= ${binary:Version})
Description: Utilities for using CWL documents
 cwl-docker-extract - cache or pre-pull all software container images referenced
 in a CWL CommandLineTool or CWL Workflow (including all referenced
 CommandLineTools and sub-Workflows and so on).
 .
 cwl-cite-extract - prints all software packages found (recursively) in the
 specified CWL document.
 .
 cwl-expression-refactor - refactors CWL documents so that any CWL Expression
 evaluations are separate steps (either CWL ExpressionTools or CWL
 CommandLineTools). This allows execution by CWL engines that do not want to
 support inline expression evaluation outside of concrete steps, or do not want
 to directly support CWL's optional InlineJavascriptRequirement at all.
 .
 cwl-graph-split - Splits a packed CWL document file into multiple files.
 Packed CWL documents use the $graph construct to contain multiple CWL Process
 objects (Workflow, CommandLineTool, ExpressionTool, Operation). Typically
 packed CWL documents contain a CWL Workflow under the name "main" and the
 workflow steps (including any sub-workflows).
 .
 cwl-normalizer - Normalizes a CWL document all its dependencies into a single
 JSON format CWL document, upgrading to CWL v1.2, as needed. Can optionally
 refactor CWL Expressions into separate steps in the manner of
 cwl-expression-refactor.

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=cwl-utils

export PYBUILD_TEST_ARGS=--ignore-glob=*/test_graph_split.py -k 'not test_load_document_with_remote_uri'
# test_graph_split: requires cwlformat, which is not packeged
# test_load_document_with_remote_uri: requires external resource

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
	dh_auto_test -- --test-pytest

override_dh_install:
	dh_install
	rm debian/python3-cwl-utils/usr/lib/python3*/dist-packages/cwl_utils/tests/test_graph_split.py
	rm -Rf debian/python3-cwl-utils/usr/bin

=== debian/tests/control ===
Tests: run-tests
Depends: @, python3-pytest-xdist, python3-pytest
Restrictions: allow-stderr

## cwl-utils 0.21

=== debian/changelog ===
cwl-utils (0.21-1) unstable; urgency=medium

  * New upstream version
  * d/control, d/tests/control: new test dependency: pytest-mock & nodejs

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 29 Nov 2022 17:36:56 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,10 @@
                python3-schema-salad (>= 8.3),
                python3-filelock <!nocheck>,
                python3-setuptools,
-               python3-pytest <!nocheck>
+               python3-pytest <!nocheck>,
+               python3-pytest-mock <!nocheck>,
+               python3-mock <!nocheck>,
+               nodejs <!nocheck>
 Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils
 Vcs-Git: https://salsa.debian.org/python-team/packages/cwl-utils.git

=== debian/tests/control ===
Tests: run-tests
Depends: @, python3-pytest-xdist, python3-pytest, python3-pytest-mock, python3-mock, nodejs
Restrictions: allow-stderr

## cwl-utils 0.22

=== debian/changelog ===
cwl-utils (0.22-1) unstable; urgency=medium

  * suggest cwl-upgrader for the cwl-normalizer tool
  * New upstream version
  * Standards-Version: 4.6.2 (routine-update)
  * Add build-dep on cwlformat and restore the graph-split test.
  * fix install location for scripts; add missing explicit python3 dep

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 27 Jan 2023 10:07:36 +0100

=== debian/control ===
--- 
+++ 
@@ -6,6 +6,7 @@
 Build-Depends: debhelper-compat (= 13),
                dh-python,
                cwl-upgrader,
+               cwlformat,
                python3-all,
                python3-cachecontrol,
                python3-packaging,
@@ -18,7 +19,7 @@
                python3-pytest-mock <!nocheck>,
                python3-mock <!nocheck>,
                nodejs <!nocheck>
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils
 Vcs-Git: https://salsa.debian.org/python-team/packages/cwl-utils.git
 Homepage: https://github.com/common-workflow-language/cwl-utils
@@ -38,7 +39,8 @@
 
 Package: cwl-utils
 Architecture: all
-Depends: ${misc:Depends}, python3-cwl-utils (= ${binary:Version})
+Depends: ${misc:Depends}, python3-cwl-utils (= ${binary:Version}), python3
+Suggests: cwl-upgrader, cwlformat
 Description: Utilities for using CWL documents
  cwl-docker-extract - cache or pre-pull all software container images referenced
  in a CWL CommandLineTool or CWL Workflow (including all referenced
@@ -57,9 +59,9 @@
  Packed CWL documents use the $graph construct to contain multiple CWL Process
  objects (Workflow, CommandLineTool, ExpressionTool, Operation). Typically
  packed CWL documents contain a CWL Workflow under the name "main" and the
- workflow steps (including any sub-workflows).
+ workflow steps (including any sub-workflows) [requires cwlformat].
  .
  cwl-normalizer - Normalizes a CWL document all its dependencies into a single
  JSON format CWL document, upgrading to CWL v1.2, as needed. Can optionally
  refactor CWL Expressions into separate steps in the manner of
- cwl-expression-refactor.
+ cwl-expression-refactor [requires cwl-upgrader].

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=cwl-utils

export PYBUILD_TEST_ARGS=-k 'not (test_load_document_with_remote_uri or test_graph_split)'
# test_load_document_with_remote_uri: requires external resource
# test_graph_split: requires external resource

%:
	dh $@ --with python3 --buildsystem=pybuild

override_dh_auto_test:
	dh_auto_test -- --test-pytest

override_dh_install:
	dh_install
	rm -Rf debian/python3-cwl-utils/usr/bin

## cwl-utils 0.28

=== Makefile ===
--- 
+++ 
@@ -29,8 +29,8 @@
 PYSOURCES=$(filter-out $(MODULE)/parser/cwl_v%,$(shell find $(MODULE) -name "*.py")) \
 	  $(wildcard tests/*.py) create_cwl_from_objects.py load_cwl_by_path.py \
 	  setup.py ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
-DEVPKGS=diff_cover black pylint pep257 pydocstyle flake8 tox tox-pyenv \
-	isort wheel autoflake flake8-bugbear pyupgrade bandit \
+DEVPKGS=diff_cover  pylint pep257 pydocstyle flake8 tox tox-pyenv \
+	isort wheel autoflake pyupgrade bandit -rlint-requirements.txt \
 	-rtest-requirements.txt -rmypy-requirements.txt
 DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
 	   python-flake8 python-mock shellcheck
@@ -79,7 +79,7 @@
 
 ## clean                  : clean up all temporary / machine-generated files
 clean: FORCE
-	rm -f ${MODILE}/*.pyc tests/*.pyc
+	rm -f ${MODULE}/*.pyc tests/*.pyc
 	python setup.py clean --all || true
 	rm -Rf .coverage
 	rm -f diff-cover.html
@@ -109,8 +109,8 @@
 	codespell -w $(shell git ls-files | grep -v mypy-stubs)
 
 ## format                 : check/fix all code indentation and formatting (runs black)
-format: $(PYSOURCES)
-	black $^
+format: $(PYSOURCES) FORCE
+	black $(PYSOURCES)
 
 format-check: $(PYSOURCES)
 	black --diff --check $^
@@ -152,7 +152,7 @@
 
 ## test                   : run the cwl-utils test suite
 test: $(PYSOURCES)
-	python -m pytest -rs ${PYTEST_EXTRA}
+	python -m pytest -rsx ${PYTEST_EXTRA}
 
 ## testcov                : run the cwl-utils test suite and collect coverage
 testcov: $(PYSOURCES)

=== debian/changelog ===
cwl-utils (0.28-1) unstable; urgency=medium

  * New upstream version
  * Build-Depends: s/dh-python/dh-sequence-python3/ (routine-update)
  * d/rules: skip test test_remote_packing* during offline builds

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 08 Aug 2023 20:01:43 +0200

## cwl-utils 0.29

=== requirements.txt ===
cwl-upgrader >= 1.2.3
packaging
rdflib
requests
schema-salad >= 8.3.20220825114525, < 9
ruamel.yaml >= 0.17.6, < 0.18;python_version>='3.7'
ruamel.yaml >= 0.16.12, < 0.18

=== debian/changelog ===
cwl-utils (0.29-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 11 Sep 2023 14:26:24 +0200

=== debian/control ===
--- 
+++ 
@@ -4,7 +4,7 @@
 Maintainer: Debian Python Team <team+python@tracker.debian.org>
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
-               dh-python,
+               dh-sequence-python3,
                cwl-upgrader,
                cwlformat,
                python3-all,

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=cwl-utils

export PYBUILD_TEST_ARGS=-k 'not (test_load_document_with_remote_uri or test_graph_split or test_remote_packing)'
# test_load_document_with_remote_uri: requires external resource
# test_graph_split: requires external resource

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_test:
	dh_auto_test -- --test-pytest

override_dh_install:
	dh_install
	rm -Rf debian/python3-cwl-utils/usr/bin

## cwl-utils 0.32

=== Makefile ===
--- 
+++ 
@@ -30,8 +30,8 @@
 	  $(wildcard tests/*.py) create_cwl_from_objects.py load_cwl_by_path.py \
 	  setup.py ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
 DEVPKGS=diff_cover  pylint pep257 pydocstyle flake8 tox tox-pyenv \
-	isort wheel autoflake pyupgrade bandit -rlint-requirements.txt \
-	-rtest-requirements.txt -rmypy-requirements.txt
+	isort wheel autoflake pyupgrade bandit auto-walrus \
+	-rlint-requirements.txt -rtest-requirements.txt -rmypy-requirements.txt
 DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
 	   python-flake8 python-mock shellcheck
 VERSION=v$(shell echo $$(tail -n 1 cwl_utils/__meta__.py | awk '{print $$3}'))
@@ -173,14 +173,12 @@
 mypy: $(filter-out setup.py,${PYSOURCES})
 	MYPYPATH=$$MYPYPATH:mypy-stubs mypy $^
 
-mypy_3.6: $(filter-out setup.py,${PYSOURCES})
-	MYPYPATH=$$MYPYPATH:mypy-stubs mypy --python-version 3.6 $^
-
 shellcheck: FORCE
 	shellcheck release-test.sh
 
 pyupgrade: $(PYSOURCES)
-	pyupgrade --exit-zero-even-if-changed --py36-plus $^
+	pyupgrade --exit-zero-even-if-changed --py38-plus $^
+	auto-walrus $^
 
 release-test: FORCE
 	git diff-index --quiet HEAD -- || ( echo You have uncommitted changes, please commit them and try again; false )

=== requirements.txt ===
cwl-upgrader >= 1.2.3
packaging
rdflib
requests
schema-salad >= 8.5, < 9
ruamel.yaml >= 0.17.6, < 0.19
importlib_resources;python_version<'3.9'

=== debian/changelog ===
cwl-utils (0.32-1) unstable; urgency=medium

  * New upstream version. Will break cwltool prior to 3.1.20231206180100

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 02 Jan 2024 14:24:48 +0100

=== debian/control ===
--- 
+++ 
@@ -30,6 +30,7 @@
 Depends: ${misc:Depends}, ${python3:Depends}, python3-filelock
 Recommends: ${python3:Recommends}
 Suggests: ${python3:Suggests}, cwl-utils
+Breaks: cwltool (<< 3.1.20231206180100)
 Description: Python Utilities and Autogenerated Classes for CWL v1.0 - v1.2
  The autogenerated classes can create, load, and save objects based upon CWL
  (the Common Workflow Language open standards for executable descriptions of

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=cwl-utils

export PYBUILD_TEST_ARGS=-k 'not (test_load_document_with_remote_uri or test_graph_split or test_remote_packing)'
export PYBUILD_TEST_PYTEST=1
# test_load_document_with_remote_uri: requires external resource
# test_graph_split: requires external resource

%:
	dh $@ --buildsystem=pybuild

override_dh_install:
	dh_install
	rm -Rf debian/python3-cwl-utils/usr/bin

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/cwl-utils/cwl-utils-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## cwl-utils 0.33

=== Makefile ===
--- 
+++ 
@@ -28,9 +28,9 @@
 # `[[` conditional expressions.
 PYSOURCES=$(filter-out $(MODULE)/parser/cwl_v%,$(shell find $(MODULE) -name "*.py")) \
 	  $(wildcard tests/*.py) create_cwl_from_objects.py load_cwl_by_path.py \
-	  setup.py ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
-DEVPKGS=diff_cover  pylint pep257 pydocstyle flake8 tox tox-pyenv \
-	isort wheel autoflake pyupgrade bandit auto-walrus \
+	  ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
+DEVPKGS=build diff_cover pylint pep257 pydocstyle 'tox<4' tox-pyenv \
+	wheel autoflake pyupgrade bandit auto-walrus \
 	-rlint-requirements.txt -rtest-requirements.txt -rmypy-requirements.txt
 DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
 	   python-flake8 python-mock shellcheck
@@ -52,8 +52,8 @@
 install-dep: install-dependencies
 
 install-dependencies:
+	pip install -U pip setuptools wheel
 	pip install --upgrade $(DEVPKGS)
-	pip install -r requirements.txt -r mypy-requirements.txt -r docs/requirements.txt
 
 ## install-deb-dep        : install many of the dev dependencies via apt-get
 install-deb-dep:
@@ -65,13 +65,14 @@
 
 ## dev                    : install the cwl-utils package in dev mode
 dev: install-dep
+	pip install -U pip setuptools wheel
 	pip install -e .$(EXTRAS)
 
 ## dist                   : create a module package for distribution
 dist: dist/${MODULE}-$(VERSION).tar.gz
 
 dist/${MODULE}-$(VERSION).tar.gz: $(SOURCES)
-	python setup.py sdist bdist_wheel
+	python -m build
 
 ## docs                   : make the docs
 docs: FORCE
@@ -80,7 +81,6 @@
 ## clean                  : clean up all temporary / machine-generated files
 clean: FORCE
 	rm -f ${MODULE}/*.pyc tests/*.pyc
-	python setup.py clean --all || true
 	rm -Rf .coverage
 	rm -f diff-cover.html
 
@@ -98,7 +98,7 @@
 	pydocstyle --add-ignore=D100,D101,D102,D103 $^ || true
 
 pydocstyle_report.txt: $(PYSOURCES)
-	pydocstyle setup.py $^ > $@ 2>&1 || true
+	pydocstyle $^ > $@ 2>&1 || true
 
 ## diff_pydocstyle_report : check Python docstring style for changed files only
 diff_pydocstyle_report: pydocstyle_report.txt
@@ -170,7 +170,7 @@
 	@git log --format='%aN,%aE' | sort -u | grep -v 'root'
 
 mypy3: mypy
-mypy: $(filter-out setup.py,${PYSOURCES})
+mypy: ${PYSOURCES}
 	MYPYPATH=$$MYPYPATH:mypy-stubs mypy $^
 
 shellcheck: FORCE
@@ -186,8 +186,8 @@
 
 release: release-test
 	. testenv2/bin/activate && \
-		python testenv2/src/${PACKAGE}/setup.py sdist bdist_wheel
-	. testenv2/bin/activate && \
+		pip install build && \
+		python -m build testenv2/src/${PACKAGE} && \
 		pip install twine && \
 		twine upload testenv2/src/${PACKAGE}/dist/* && \
 		git tag ${VERSION} && git push --tags
@@ -210,7 +210,7 @@
 cwl_utils/parser/cwl_v1_2.py: FORCE
 	schema-salad-tool --codegen python \
 		--codegen-parser-info "org.w3id.cwl.v1_2" \
-		https://github.com/common-workflow-language/cwl-v1.2/raw/1.2.1_proposed/CommonWorkflowLanguage.yml \
+		https://github.com/common-workflow-language/cwl-v1.2/raw/codegen/CommonWorkflowLanguage.yml \
 		> $@
 
 regen_parsers: cwl_utils/parser/cwl_v1_*.py

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-sphinx >= 2.2
+sphinx >= 2.2, <7
 sphinx-rtd-theme
 sphinx-autoapi
 sphinx-autodoc-typehints

=== debian/changelog ===
cwl-utils (0.33-1) unstable; urgency=medium

  * New upstream version
  * d/control: Build in a PEP-517 manner

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 10 Apr 2024 16:30:55 +0300

cwl-utils (0.32-2) unstable; urgency=medium

  * Team upload.
  * Remove dependency on python3-mock.

 -- Alexandre Detiste <tchet@debian.org>  Thu, 28 Mar 2024 23:14:00 +0100

=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Uploaders: Michael R. Crusoe <crusoe@debian.org>
 Build-Depends: debhelper-compat (= 13),
                dh-sequence-python3,
+               pybuild-plugin-pyproject,
                cwl-upgrader,
                cwlformat,
                python3-all,
@@ -17,7 +18,6 @@
                python3-setuptools,
                python3-pytest <!nocheck>,
                python3-pytest-mock <!nocheck>,
-               python3-mock <!nocheck>,
                nodejs <!nocheck>
 Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils

## cwl-utils 0.34

=== debian/changelog ===
cwl-utils (0.34-1) unstable; urgency=medium

  * Fix watch file.
  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 12 Sep 2024 15:20:54 +0200

## cwl-utils 0.35

=== docs/requirements.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-sphinx >= 2.2, <7
+sphinx >= 2.2, < 9
 sphinx-rtd-theme
 sphinx-autoapi
 sphinx-autodoc-typehints

=== debian/changelog ===
cwl-utils (0.35-1) unstable; urgency=medium

  * New upstream version
  * d/control: suggest "cwl-runner"
  * d/rules: make sure all test CWL documents are marked executable

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 23 Oct 2024 10:48:08 +0200

=== debian/control ===
--- 
+++ 
@@ -29,7 +29,7 @@
 Architecture: all
 Depends: ${misc:Depends}, ${python3:Depends}, python3-filelock
 Recommends: ${python3:Recommends}
-Suggests: ${python3:Suggests}, cwl-utils
+Suggests: ${python3:Suggests}, cwl-utils, cwl-runner
 Breaks: cwltool (<< 3.1.20231206180100)
 Description: Python Utilities and Autogenerated Classes for CWL v1.0 - v1.2
  The autogenerated classes can create, load, and save objects based upon CWL

## cwl-utils 0.36

=== requirements.txt ===
cwl-upgrader >= 1.2.3
packaging
rdflib
requests
schema-salad >= 8.8.20241206093842, < 9
ruamel.yaml >= 0.17.6, < 0.19

=== debian/changelog ===
cwl-utils (0.36-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)
  * d/control: needs newer python3-schema-salad

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 16 Dec 2024 00:10:50 +0100

=== debian/control ===
--- 
+++ 
@@ -13,13 +13,13 @@
                python3-packaging,
                python3-rdflib,
                python3-requests,
-               python3-schema-salad (>= 8.3),
+               python3-schema-salad (>= 8.8.20241206093842),
                python3-filelock <!nocheck>,
                python3-setuptools,
                python3-pytest <!nocheck>,
                python3-pytest-mock <!nocheck>,
                nodejs <!nocheck>
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils
 Vcs-Git: https://salsa.debian.org/python-team/packages/cwl-utils.git
 Homepage: https://github.com/common-workflow-language/cwl-utils

=== debian/rules ===
--- 
+++ 
@@ -10,6 +10,6 @@
 %:
 	dh $@ --buildsystem=pybuild
 
-override_dh_install:
-	dh_install
+execute_after_dh_install:
 	rm -Rf debian/python3-cwl-utils/usr/bin
+	find debian/python3-cwl-utils -name "*.cwl" | xargs chmod a+x

=== debian/tests/control ===
Tests: run-tests
Depends: @, python3-pytest-xdist, python3-pytest, python3-pytest-mock, python3-mock, nodejs, cwlformat
Restrictions: allow-stderr

Test-Command: cwl-cite-extract --help && cwl-docker-extract --help && cwl-expression-refactor --help && cwl-normalizer --help
Depends: cwl-utils
Restrictions: superficial

Test-Command: cwl-graph-split --help
Depends: cwl-utils, cwlformat
Restrictions: superficial

## cwl-utils 0.37

=== Makefile ===
--- 
+++ 
@@ -29,10 +29,10 @@
 PYSOURCES=$(filter-out $(MODULE)/parser/cwl_v%,$(shell find $(MODULE) -name "*.py")) \
 	  $(wildcard tests/*.py) create_cwl_from_objects.py load_cwl_by_path.py \
 	  ${MODULE}/parser/cwl_v1_?_utils.py docs/conf.py
-DEVPKGS=build diff_cover pylint pep257 pydocstyle 'tox<4' tox-pyenv \
+DEVPKGS=build diff_cover pylint pep257 ruff 'tox<4' tox-pyenv \
 	wheel autoflake pyupgrade bandit auto-walrus \
 	-rlint-requirements.txt -rtest-requirements.txt -rmypy-requirements.txt
-DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage pydocstyle sloccount \
+DEBDEVPKGS=pep8 python-autopep8 pylint python-coverage ruff sloccount \
 	   python-flake8 python-mock shellcheck
 VERSION=v$(shell echo $$(tail -n 1 cwl_utils/__meta__.py | awk '{print $$3}'))
 mkfile_dir := $(dir $(abspath $(lastword $(MAKEFILE_LIST))))
@@ -45,8 +45,8 @@
 help: Makefile
 	@sed -n 's/^##//p' $<
 
-## cleanup                : shortcut for "make sort_imports format flake8 diff_pydocstyle_report"
-cleanup: sort_imports format flake8 diff_pydocstyle_report
+## cleanup                : shortcut for "make sort_imports format flake8 pydocstyle"
+cleanup: sort_imports format flake8 pydocstyle
 
 ## install-dep            : install most of the development dependencies via pip
 install-dep: install-dependencies
@@ -95,14 +95,7 @@
 pep257: pydocstyle
 ## pydocstyle             : check Python docstring style
 pydocstyle: $(PYSOURCES)
-	pydocstyle --add-ignore=D100,D101,D102,D103 $^ || true
-
-pydocstyle_report.txt: $(PYSOURCES)
-	pydocstyle $^ > $@ 2>&1 || true
-
-## diff_pydocstyle_report : check Python docstring style for changed files only
-diff_pydocstyle_report: pydocstyle_report.txt
-	diff-quality --compare-branch=main --violations=pydocstyle --fail-under=100 $^
+	ruff check $^
 
 ## codespell              : check for common misspellings
 codespell:
@@ -177,7 +170,7 @@
 	shellcheck release-test.sh
 
 pyupgrade: $(PYSOURCES)
-	pyupgrade --exit-zero-even-if-changed --py38-plus $^
+	pyupgrade --exit-zero-even-if-changed --py39-plus $^
 	auto-walrus $^
 
 release-test: FORCE
@@ -198,19 +191,19 @@
 cwl_utils/parser/cwl_v1_0.py: FORCE
 	schema-salad-tool --codegen python \
 		--codegen-parser-info "org.w3id.cwl.v1_0" \
-		https://github.com/common-workflow-language/common-workflow-language/raw/codegen/v1.0/CommonWorkflowLanguage.yml \
+		https://github.com/common-workflow-language/common-workflow-language/raw/codegen/v1.0/extensions.yml \
 		> $@
 
 cwl_utils/parser/cwl_v1_1.py: FORCE
 	schema-salad-tool --codegen python \
 		--codegen-parser-info "org.w3id.cwl.v1_1" \
-		https://github.com/common-workflow-language/cwl-v1.1/raw/codegen/CommonWorkflowLanguage.yml \
+		https://github.com/common-workflow-language/cwl-v1.1/raw/codegen/extensions.yml \
 		> $@
 
 cwl_utils/parser/cwl_v1_2.py: FORCE
 	schema-salad-tool --codegen python \
 		--codegen-parser-info "org.w3id.cwl.v1_2" \
-		https://github.com/common-workflow-language/cwl-v1.2/raw/codegen/CommonWorkflowLanguage.yml \
+		https://github.com/common-workflow-language/cwl-v1.2/raw/codegen/extensions.yml \
 		> $@
 
 regen_parsers: cwl_utils/parser/cwl_v1_*.py

=== debian/changelog ===
cwl-utils (0.37-1) unstable; urgency=medium

  * New upstream version
  * Standards-Version: 4.7.2 (routine-update)
  * d/control: new dependency: python3-jsonschema
  * Added patch to copy in the remote data used for the input schema
    generation tests.
  * Switch from manual autopkgtest to autopkgtest-pkg-pybuild
  * Run the tests in parallel

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 13 Mar 2025 17:55:54 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,8 +1,10 @@
 #! /usr/bin/make -f
+
+include /usr/share/dpkg/default.mk
 
 export PYBUILD_NAME=cwl-utils
 
-export PYBUILD_TEST_ARGS=-k 'not (test_load_document_with_remote_uri or test_graph_split or test_remote_packing)'
+export PYBUILD_TEST_ARGS=$(DEB_BUILD_OPTION_PARALLEL:%=-n %) -k 'not (test_load_document_with_remote_uri or test_graph_split or test_remote_packing)' --pyargs cwl_utils
 export PYBUILD_TEST_PYTEST=1
 # test_load_document_with_remote_uri: requires external resource
 # test_graph_split: requires external resource

## cwl-utils 0.40

=== Makefile ===
--- 
+++ 
@@ -145,11 +145,11 @@
 
 ## test                   : run the cwl-utils test suite
 test: $(PYSOURCES)
-	python -m pytest -rsx ${PYTEST_EXTRA}
+	python -m pytest ${PYTEST_EXTRA}
 
 ## testcov                : run the cwl-utils test suite and collect coverage
 testcov: $(PYSOURCES)
-	pytest --cov ${PYTEST_EXTRA}
+	python -m pytest --cov ${PYTEST_EXTRA}
 
 sloccount.sc: $(PYSOURCES) Makefile
 	sloccount --duplicates --wide --details $^ > $@

=== requirements.txt ===
cwl-upgrader >= 1.2.3
packaging
rdflib
requests
schema-salad >= 8.8.20250205075315,<9
ruamel.yaml >= 0.17.6, < 0.19
typing_extensions;python_version<'3.10'

=== docs/requirements.txt ===
sphinx >= 2.2, < 9
sphinx-rtd-theme
sphinx-autoapi
sphinx-autodoc-typehints
sphinxcontrib-autoprogram

=== debian/changelog ===
cwl-utils (0.40-1) unstable; urgency=medium

  * New upstream version
  * Set upstream metadata fields: Documentation.
  * Patch deleted, it was applied upstream.
  * Add patch to skip two tests that require cwltool, to avoid a
    circular dependency.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 30 Sep 2025 15:02:20 +0200

=== debian/control ===
--- 
+++ 
@@ -17,13 +17,16 @@
                python3-filelock <!nocheck>,
                python3-setuptools,
                python3-pytest <!nocheck>,
+               python3-pytest-xdist <!nocheck>,
                python3-pytest-mock <!nocheck>,
-               nodejs <!nocheck>
-Standards-Version: 4.7.0
+               nodejs <!nocheck>,
+               python3-jsonschema <!nocheck>
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/python-team/packages/cwl-utils
 Vcs-Git: https://salsa.debian.org/python-team/packages/cwl-utils.git
 Homepage: https://github.com/common-workflow-language/cwl-utils
 Rules-Requires-Root: no
+Testsuite: autopkgtest-pkg-pybuild
 
 Package: python3-cwl-utils
 Architecture: all

=== debian/rules ===
#! /usr/bin/make -f

include /usr/share/dpkg/default.mk

export PYBUILD_NAME=cwl-utils

export PYBUILD_TEST_ARGS=$(DEB_BUILD_OPTION_PARALLEL:%=-n %) -k 'not (test_load_document_with_remote_uri or test_graph_split or test_remote_packing or test_graph_split_offline or test_graph_split_json_offline)' --pyargs cwl_utils
export PYBUILD_TEST_PYTEST=1
# test_load_document_with_remote_uri: requires external resource
# test_graph_split: requires external resource
# test_graph_split_offline: requires cwltool, skip to avoid circular dependency
# test_graph_split_json_offline: requires cwltool, skip to avoid circular dependency

%:
	dh $@ --buildsystem=pybuild

execute_after_dh_install:
	rm -Rf debian/python3-cwl-utils/usr/bin
	find debian/python3-cwl-utils -name "*.cwl" | xargs chmod a+x

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/cwl-utils/cwl[-_]utils-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
